import { DefinitionsService } from "../compose-schema.ts";
import { ComposeStack } from "./stack.ts";

export class Service {
  constructor(
    public readonly stack: ComposeStack,
    public readonly name: string,
    public options: DefinitionsService
  ) {
    this.stack.addService(this);
  }

  toCompose(): DefinitionsService {
    return this.options;
  }
}
