import { DefinitionsNetwork } from "../compose-schema.ts";
import { ComposeStack } from "./stack.ts";

export class Network {
  constructor(
    public readonly stack: ComposeStack,
    public readonly name: string,
    public options: DefinitionsNetwork
  ) {
    this.stack.addNetwork(this);
  }

  toCompose(): DefinitionsNetwork {
    return this.options;
  }
}
