import { DefinitionsVolume } from "../compose-schema.ts";
import { ComposeStack } from "./stack.ts";

export class Volume {
  constructor(
    public readonly stack: ComposeStack,
    public readonly name: string,
    public options: DefinitionsVolume
  ) {
    this.stack.addVolume(this);
  }

  toCompose(): DefinitionsVolume {
    return this.options;
  }
}
